=== debian/changelog ===
netdata (1.47.2-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.2.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 30 Sep 2024 06:58:08 +0200

netdata (1.47.1-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.1.
  * Updating chown in postinst for /usr/lib to /usr/libexec move in
    netdata 1.47 (Closes: #1079714).
  * Updating lintian overrides for /usr/lib to /usr/libexec move in
    netdata 1.47.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 10 Sep 2024 22:17:14 +0200

netdata (1.47.0-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.0.
  * Updating apt command in README.Debian for newer apt.
  * Removing manual python3-six depends, not needed anymore (Closes:
    #1061684).
  * Removing use-system-exim4.patch, not needed anymore.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 26 Aug 2024 10:15:55 +0200

netdata (1.46.3-2) experimental; urgency=medium

  * Uploading to experimental.
  * Correcting watch file.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 25 Jul 2024 06:39:50 +0200

netdata (1.46.3-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 1.46.3.
  * Updating to standards-version 4.7.0.
  * Listing excluded files in copyright.
  * Refreshing use-system-python.patch.
  * Refreshing use-system-exim4.patch.
  * Refreshing use-python3.patch.
  * Refreshing send-email.patch.
  * Removing fix-FTCBFS.patch, not neded anymore.
  * Updating packaging for upstreams move to cmake.
  * Adding newly required build-depends.
  * Temporarily disabling some plugins to fix FTBFS and no-network during
    build.
  * Updating paths for upstreams /usr/lib/netdata to /usr/libexec/netdata
    transition.
  * Updating netdata-core.install for newly added files.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Wed, 24 Jul 2024 13:04:39 +0200
