=== debian/changelog ===
netdata (1.47.5-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.5.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 09 Nov 2024 09:26:54 +0100
