=== debian/watch ===
version=4
opts="pgpmode=auto" \
https://github.com/netdata/netdata/tags .*/v?(\d\S+)\.tar\.gz
