=== debian/changelog ===
netdata (2.0.3+dfsg-3) sid; urgency=medium

  * Uploading to unstable, not part of trixie anyway.
  * Updating vcs fields.
  * Removing myself from maintainer, orphaning package (see #1106233 for
    reasons).

 -- Daniel Baumann <mail@daniel-baumann.ch>  Wed, 21 May 2025 21:22:25 +0200

netdata (2.0.3+dfsg-2) experimental; urgency=medium

  * Updating vcs fields.
  * Trimming changelog.
  * Updating my email address.
  * Updating year in debian copyright for 2025.
  * Enabling prometheus remote write, thanks to Thomas Goirand
    <zigo@debian.org> (Closes: #1092600).

 -- Daniel Baumann <daniel@debian.org>  Wed, 21 May 2025 19:39:25 +0200

netdata (2.0.3+dfsg-1) experimental; urgency=medium

  * Merging upstream version 2.0.3+dfsg (Closes: #923993, #1042533,
    #1045145).
  * Adding upstream target in rules.
  * Removing use-system-python.patch.
  * Refreshing use-python3.patch.
  * Adding patch to use system pyaml3 directly rather than first trying
    embedded copy (that is removed in Debian).
  * Addin patch to use system python modules rather than first trying
    embedded copies (that are removed in Debian).
  * Adding patch to use system dlib.
  * Updating copyright for new upstream version.
  * Removing removed cmake build options.
  * Disabling to download and embedd dashboard binaries during built.
  * Removing netdata frontend packaging, upstream split the sources out to
    netdata-dashboard.
  * Folding netdata-core into netdata itself.
  * Updating build-depends for new upstream version.
  * Enabling machine-learning support (Closes: #1054354).
  * Including api files in netdata, later being used via netdata-
    dashboard.
  * Updating todo file.
  * Updating watch file.

 -- Daniel Baumann <daniel@debian.org>  Mon, 25 Nov 2024 18:14:34 +0100
