=== debian/control ===
Source: netdata
Section: net
Priority: optional
Maintainer: Lennart Weller <lhw@ring0.de>
Uploaders:
 Federico Ceratto <federico@debian.org>,
Build-Depends:
 cmake,
 curl,
 debhelper-compat (= 13),
 libbpf-dev,
 libcap-dev,
 libcups2-dev,
 libcurl4-openssl-dev,
 libdlib-dev,
 libelf-dev,
 libh2o-dev-common,
 libipmimonitoring-dev,
 libjson-c-dev,
 libjudy-dev,
 liblz4-dev,
 libmnl-dev,
 libmosquitto-dev,
 libnetfilter-acct-dev,
 libpcre2-dev,
 libprotobuf-c-dev,
 libprotobuf-dev,
 libsnappy-dev,
 libssl-dev,
 libsystemd-dev,
 libuv1-dev,
 libwebsockets-dev,
 libyaml-dev,
 libzstd-dev,
 lm-sensors,
 pkgconf,
 protobuf-c-compiler,
 protobuf-compiler,
 python3,
 uuid-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://www.netdata.cloud
Vcs-Browser: https://salsa.debian.org/debian/netdata
Vcs-Git: https://salsa.debian.org/debian/netdata.git

Package: netdata
Section: net
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libcap2-bin,
 lsb-base,
 passwd,
 sse2-support [i386],
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 curl,
 netdata-plugins-bash,
 netdata-plugins-python,
Suggests:
 apcupsd,
 iproute2,
 iw,
 lm-sensors,
 nc,
Breaks:
 netdata-apache2,
 netdata-core (<< 2),
 netdata-core-no-sse (<< 2),
 netdata-web,
Replaces:
 netdata-apache2,
 netdata-core,
 netdata-core-no-sse,
 netdata-web,
Description: real-time performance monitoring
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 It can run autonomously without any third party components or it can be
 integrated to existing monitoring tool chains (Prometheus, Graphite,
 OpenTSDB, Kafka, Grafana, etc).

Package: netdata-core
Section: net
Architecture: all
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
Description: real-time performance monitoring (transitional package)
 Package to ease upgrading from older netdata-core package to the new
 netdata package.
 .
 This package can be purged at anytime once the netdata package has been
 installed.

Package: netdata-core-no-sse
Section: net
Architecture: i386
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
Description: real-time performance monitoring (transitional package)
 Package to ease upgrading from older netdata-core-no-sse package to the new
 netdata package.
 .
 This package can be purged at anytime once the netdata package has been
 installed.

Package: netdata-plugins-bash
Section: net
Architecture: all
Multi-Arch: foreign
Depends:
 netdata (>= ${source:Version}),
 ${misc:Depends},
Suggests:
 fping,
Provides:
 netdata-plugins,
Enhances:
 netdata,
Description: real-time performance monitoring (bash plugins)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the plugins using bash.

Package: netdata-plugins-python
Section: net
Architecture: all
Multi-Arch: foreign
Depends:
 netdata (>= ${source:Version}),
 python3,
 python3-monotonic,
 python3-urllib3 (>= 1.22),
 python3-yaml,
 ${misc:Depends},
Suggests:
 python3-psycopg2,
 python3-pymysql,
 python3-requests,
Provides:
 netdata-plugins,
Enhances:
 netdata,
Description: real-time performance monitoring (python plugins)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the plugins using python.
