=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//" \
https://github.com/netdata/netdata/tags .*/v?(\d\S+)\.tar\.gz
